/*
 * generated by Xtext
 */
package com.javadude.beans2.dsl.generator

import com.javadude.beans2.dsl.beansDsl.ClassType
import com.javadude.beans2.dsl.beansDsl.EnumType
import com.javadude.beans2.dsl.beansDsl.Model
import com.javadude.beans2.dsl.beansDsl.Type
import java.util.List
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.IFileSystemAccess
import org.eclipse.xtext.generator.IGenerator
import com.javadude.beans2.dsl.beansDsl.PrimitiveType
import com.javadude.beans2.dsl.beansDsl.ListField
import com.javadude.beans2.dsl.beansDsl.SimpleField
import java.util.HashSet

/**
 * Generates code from your model files on save.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#TutorialCodeGeneration
 */
class BeansDslGenerator implements IGenerator {
	var imports = new HashSet<String>
	
	override void doGenerate(Resource resource, IFileSystemAccess fsa) {
		var model = resource.contents.head as Model
		for(Type t : model.types.filter[!(it instanceof PrimitiveType)]) {
			imports.clear
			fsa.generateFile('''«model.packageName.replace('.', '/')»/«t.name».java''', t.genApi(model).gen(model))
		}
		for(Type t : model.types.filter[it instanceof ClassType]) {
			imports.clear
			fsa.generateFile('''«model.packageName.replace('.', '/')»/«t.name»Impl.java''', (t as ClassType).genImpl(model).gen(model))
		}
	}
	
	def imp(String i) {
		imports.add(i)
		i.substring(i.lastIndexOf('.')+1)
	}
	
	def iList() {'java.util.List'.imp} 
	def iArrayList() {'java.util.ArrayList'.imp} 
	
	def gen(CharSequence body, Model model) '''
		package «model.packageName»;
		
		«FOR i : imports»
		import «i»;
		«ENDFOR»
		
		«body»
	'''
	
	def genImpl(ClassType t, Model model) '''
		public class «t.name»Impl implements «t.name» {
			«FOR f : t.fields»
				«f.genField»
				«f.genMethods»
			«ENDFOR»
		}
	'''
	
	def dispatch genMethods(ListField f) '''
		public «iList»<«f.type.name»> get«f.name.toFirstUpper»() {
			return this.«f.name»;
		}
	'''
	def dispatch genMethods(SimpleField f) '''
		public void set«f.name.toFirstUpper»(«f.type.name» «f.name») {
			«IF f.bound»
			«f.type.name» old = this.«f.name»;
			«ENDIF»
			this.«f.name» = «f.name»;
			«IF f.bound»
			pcs.fire...
			«ENDIF»
		}
		public «f.type.name» get«f.name.toFirstUpper»() {
			return this.«f.name»;
		}
	'''
	def dispatch genApiMethods(ListField f) '''
		public «iList»<«f.type.name»> get«f.name.toFirstUpper»();
	'''
	def dispatch genApiMethods(SimpleField f) '''
		public void set«f.name.toFirstUpper»(«f.type.name» «f.name»);
		public «f.type.name» get«f.name.toFirstUpper»();
	'''
	
	def dispatch genField(ListField f) '''private «iList»<«f.type.name»> «f.name» = new «iArrayList»<«f.type.name»>();'''
	def dispatch genField(SimpleField f) '''private «f.type.name» «f.name»;'''
	
	def dispatch genApi(ClassType t, Model model) '''
		public interface «t.name» {
			«FOR f : t.fields»
				«f.genApiMethods»
			«ENDFOR»
		}
	'''
	
	def dispatch genApi(EnumType t, Model model) '''
		public enum «t.name» {
			«FOR v : t.values SEPARATOR ', '»
				«v.name»
			«ENDFOR»
		}
	'''
}
